// OptionsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "xkeymacs.h"
#include "OptionsDlg.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionsDlg dialog


COptionsDlg::COptionsDlg(CWnd *pParent /*=NULL*/)
	: CDialog(COptionsDlg::IDD, pParent)
{
	m_lpVersionInformation = new OSVERSIONINFO;
	m_lpVersionInformation->dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(m_lpVersionInformation);
	//{{AFX_DATA_INIT(COptionsDlg)
	//}}AFX_DATA_INIT
}

COptionsDlg::~COptionsDlg()
{
	delete m_lpVersionInformation;
}

void COptionsDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionsDlg)
	DDX_Control(pDX, IDC_M_, m_cM_);
	DDX_Control(pDX, IDC_REMAP_RIGHTWINDOWS_RIGHTALT, m_cRemapRightWindowsRightAlt);
	DDX_Control(pDX, IDC_REMAP_RIGHTCTRL_LEFTALT, m_cRemapRightCtrlLeftAlt);
	DDX_Control(pDX, IDC_REMAP_RIGHTALT_RIGHTWINDOWS, m_cRemapRightAltRightWindows);
	DDX_Control(pDX, IDC_REMAP_NONCONVERT_LEFTALT, m_cRemapNonconvertLeftAlt);
	DDX_Control(pDX, IDC_REMAP_LEFTWINDOWS_LEFTALT, m_cRemapLeftWindowsLeftAlt);
	DDX_Control(pDX, IDC_REMAP_LEFTALT_LEFTWINDOWS, m_cRemapLeftAltLeftWindows);
	DDX_Control(pDX, IDC_REMAP_CONVERT_LEFTALT, m_cRemapConvertLeftAlt);
	DDX_Control(pDX, IDC_ALT, m_cAlt);
	DDX_Control(pDX, IDC_SHIFT, m_cShift);
	DDX_Control(pDX, IDC_CTRL, m_cCtrl);
	DDX_Control(pDX, IDC_C_X_, m_cCx);
	DDX_Control(pDX, IDC_FILE_COMPLETION, m_cFileCompletion);
	DDX_Control(pDX, IDC_AUTO_RUN, m_cAutoRun);
	DDX_Control(pDX, IDC_USAGE, m_cUsage);
	DDX_Control(pDX, IDOK, m_cOK);
	DDX_Control(pDX, IDC_SWAP_ESC_BACKQUOTE, m_cSwapEscBackQuote);
	DDX_Control(pDX, IDC_REMAP_LEFTCTRL_CAPSLOCK, m_cRemapLeftCtrlCapsLock);
	DDX_Control(pDX, IDC_REMAP_CAPSLOCK_LEFTCTRL, m_cRemapCapsLockLeftCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionsDlg, CDialog)
	//{{AFX_MSG_MAP(COptionsDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionsDlg message handlers

void COptionsDlg::GetRegScanCode(LPBYTE *lplpData, LPDWORD lpcbData)
{
	CString szSubKey;
	CString szValueName;
	if (IsNT()) {
		szSubKey.LoadString(IDS_REGSUBKEY_KEYBOARD_LAYOUT);
		szValueName.LoadString(IDS_SCANCODE_MAP);
	} else if (Is9x()) {
		szSubKey.LoadString(IDS_REGSUBKEY_KEY_REMAP);
		szValueName.LoadString(IDS_0);
	} else {
		return;
	}

	HKEY hKey;
	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, szSubKey, 0, KEY_QUERY_VALUE, &hKey) == ERROR_SUCCESS) {
		// get data size
		DWORD dwType = REG_BINARY;
		RegQueryValueEx(hKey, szValueName, NULL, &dwType, NULL, lpcbData);

		// get data
		*lplpData = new BYTE[*lpcbData];
		if (*lplpData) {
			RegQueryValueEx(hKey, szValueName, NULL, &dwType, *lplpData, lpcbData);
		}
		RegCloseKey(hKey);
	}
}

void COptionsDlg::SetRegScanCode(LPBYTE lpData, DWORD dwcbData)
{
	CString szSubKey;
	CString szValueName;
	if (IsNT()) {
		szSubKey.LoadString(IDS_REGSUBKEY_KEYBOARD_LAYOUT);
		szValueName.LoadString(IDS_SCANCODE_MAP);
	} else if (Is9x()) {
		szSubKey.LoadString(IDS_REGSUBKEY_KEY_REMAP);
		szValueName.LoadString(IDS_0);
	} else {
		return;
	}

	HKEY hKey;
	if (RegCreateKeyEx(HKEY_LOCAL_MACHINE, szSubKey, 0, NULL, REG_OPTION_NON_VOLATILE,
					   KEY_SET_VALUE, NULL, &hKey, NULL) == ERROR_SUCCESS) {
		// get data size
		DWORD dwType = REG_BINARY;
		RegSetValueEx(hKey, szValueName, 0, dwType, lpData, dwcbData);

		RegCloseKey(hKey);
	}
}

BOOL COptionsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	// clear all check
	m_cAutoRun.SetCheck(0);
	m_cRemapCapsLockLeftCtrl.SetCheck(0);
	m_cRemapLeftCtrlCapsLock.SetCheck(0);
	m_cSwapEscBackQuote.SetCheck(0);
	m_cRemapLeftWindowsLeftAlt.SetCheck(0);
	m_cRemapLeftAltLeftWindows.SetCheck(0);
	m_cRemapRightWindowsRightAlt.SetCheck(0);
	m_cRemapRightAltRightWindows.SetCheck(0);
	m_cRemapNonconvertLeftAlt.SetCheck(0);
	m_cRemapConvertLeftAlt.SetCheck(0);
	m_cRemapRightCtrlLeftAlt.SetCheck(0);
	m_cCx.SetCheck(0);
	m_cM_.SetCheck(0);
	m_cShift.SetCheck(0);
	m_cCtrl.SetCheck(0);
	m_cAlt.SetCheck(0);

	// for auto run
	{
		TCHAR szFileName[MAX_PATH];
		ZeroMemory(szFileName, sizeof(szFileName));
		GetModuleFileName(NULL, szFileName, sizeof(szFileName));
		HKEY hKey;
		CString szSubKey;
		szSubKey.LoadString(IDS_REGSUBKEY_AUTORUN);
		CString szValueName;
		szValueName.LoadString(AFX_IDS_APP_TITLE);

		if (RegOpenKeyEx(HKEY_CURRENT_USER,  szSubKey, 0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS ||
			RegOpenKeyEx(HKEY_LOCAL_MACHINE, szSubKey, 0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS) {
			DWORD dwType = REG_SZ;
			TCHAR szSavedFileName[MAX_PATH];
			ZeroMemory(szSavedFileName, sizeof(szSavedFileName));
			DWORD dwBufLen = sizeof(szSavedFileName);
			RegQueryValueEx(hKey, szValueName, NULL, &dwType,
							(LPBYTE)szSavedFileName, &dwBufLen);
			RegCloseKey(hKey);

			if (!strncmp(szFileName, szSavedFileName, sizeof(szFileName))) {
				m_cAutoRun.SetCheck(1);
			}
		}
	}

	// for file and directory name completion
	if (IsNT()) {
		HKEY hKey;
		CString szSubKey;
		szSubKey.LoadString(IDS_REGSUBKEY_FILE_COMPLETION);
		CString szValueName;
		szValueName.LoadString(IDS_COMPLETION_CHAR);

		if (RegOpenKeyEx(HKEY_CURRENT_USER,  szSubKey, 0, KEY_QUERY_VALUE, &hKey) == ERROR_SUCCESS ||
			RegOpenKeyEx(HKEY_LOCAL_MACHINE, szSubKey, 0, KEY_QUERY_VALUE, &hKey) == ERROR_SUCCESS) {
			DWORD dwType = REG_DWORD;
			DWORD dwCompletionChar = 0;
			DWORD dwcbData = sizeof(dwCompletionChar);
			RegQueryValueEx(hKey, szValueName, NULL, &dwType,
							(LPBYTE)&dwCompletionChar, &dwcbData);
			RegCloseKey(hKey);
			if (dwCompletionChar == 0x9) {
				m_cFileCompletion.SetCheck(1);
			}
		}
	}

	// for remap keyboard
	// get registry data
	LPBYTE	lpData		= NULL;
	DWORD	dwcbData	= 0;
	GetRegScanCode(&lpData, &dwcbData);

	memset(m_bRemap, 0, sizeof(m_bRemap));

	// set check box
	if (IsNT()) {
		if (lpData && dwcbData) {
			// skip Version Information and Flags
			DWORD offset = 0;
			offset += 8;

			// check check boxes on the options dialog if needed
			DWORD *pdwMappings = (DWORD *)(lpData + offset);
			DWORD *pdwNullTerminator = (DWORD *)(lpData + dwcbData - 4);
			if (4 * *pdwMappings + 12 != dwcbData) {
				// illegal data
			} else if (*pdwNullTerminator != 0) {
				// illegal data
			} else {
				offset += 4;	// skip Number of Mappings

				BOOL bRemap_Esc_BackQuote = FALSE;
				BOOL bRemap_BackQuote_Esc = FALSE;
				while (offset < dwcbData - 4) {
					WORD *pwNew = (WORD *)(lpData + offset);
					WORD *pwOriginal = (WORD *)(lpData + offset + 2);

					if (*pwOriginal == SC_CAPSLOCK && *pwNew == SC_LEFT_CONTROL) {
						m_cRemapCapsLockLeftCtrl.SetCheck(1);
						m_bRemap[CapsLock_LeftCtrl] = TRUE;
					} else if (*pwOriginal == SC_LEFT_CONTROL && *pwNew == SC_CAPSLOCK) {
						m_cRemapLeftCtrlCapsLock.SetCheck(1);
						m_bRemap[LeftCtrl_CapsLock] = TRUE;
					} else if (*pwOriginal == SC_ESCAPE && *pwNew == SC_BACK_QUOTE) {
						bRemap_Esc_BackQuote = TRUE;
					} else if (*pwOriginal == SC_BACK_QUOTE && *pwNew == SC_ESCAPE) {
						bRemap_BackQuote_Esc = TRUE;
					} else if (*pwOriginal == SC_LEFT_WINDOWS && *pwNew == SC_LEFT_ALT) {
						m_cRemapLeftWindowsLeftAlt.SetCheck(1);
						m_bRemap[LeftWindows_LeftAlt] = TRUE;
					} else if (*pwOriginal == SC_LEFT_ALT && *pwNew == SC_LEFT_WINDOWS) {
						m_cRemapLeftAltLeftWindows.SetCheck(1);
						m_bRemap[LeftAlt_LeftWindows] = TRUE;
					} else if (*pwOriginal == SC_RIGHT_WINDOWS && *pwNew == SC_RIGHT_ALT) {
						m_cRemapRightWindowsRightAlt.SetCheck(1);
						m_bRemap[RightWindows_RightAlt] = TRUE;
					} else if (*pwOriginal == SC_RIGHT_ALT && *pwNew == SC_RIGHT_WINDOWS) {
						m_cRemapRightAltRightWindows.SetCheck(1);
						m_bRemap[RightAlt_RightWindows] = TRUE;
					} else if (*pwOriginal == SC_NONCONVERT && *pwNew == SC_LEFT_ALT) {
						m_cRemapNonconvertLeftAlt.SetCheck(1);
						m_bRemap[Nonconvert_LeftAlt] = TRUE;
					} else if (*pwOriginal == SC_CONVERT && *pwNew == SC_LEFT_ALT) {
						m_cRemapConvertLeftAlt.SetCheck(1);
						m_bRemap[Convert_LeftAlt] = TRUE;
					} else if (*pwOriginal == SC_RIGHT_CONTROL && *pwNew == SC_LEFT_ALT) {
						m_cRemapRightCtrlLeftAlt.SetCheck(1);
						m_bRemap[RightCtrl_LeftAlt] = TRUE;
					}

					offset += 4;	// go to next data
				}
				if (bRemap_BackQuote_Esc && bRemap_Esc_BackQuote) {
					m_cSwapEscBackQuote.SetCheck(1);
					m_bRemap[Esc_BackQuote] = TRUE;
				}
			}
		}
	} else if (Is9x()) {
		m_cFileCompletion.EnableWindow(FALSE);
		m_cSwapEscBackQuote.EnableWindow(FALSE);
		m_cRemapLeftWindowsLeftAlt.EnableWindow(FALSE);
		m_cRemapLeftAltLeftWindows.EnableWindow(FALSE);
		m_cRemapRightWindowsRightAlt.EnableWindow(FALSE);
		m_cRemapRightAltRightWindows.EnableWindow(FALSE);
		m_cRemapNonconvertLeftAlt.EnableWindow(FALSE);
		m_cRemapConvertLeftAlt.EnableWindow(FALSE);
		m_cRemapRightCtrlLeftAlt.EnableWindow(FALSE);
		if (lpData && dwcbData) {
			if (*lpData == 0x01) {
				m_cRemapCapsLockLeftCtrl.SetCheck(1);
				m_bRemap[CapsLock_LeftCtrl] = TRUE;
			}
			if (*(lpData+1) == 0x00) {
				m_cRemapLeftCtrlCapsLock.SetCheck(1);
				m_bRemap[LeftCtrl_CapsLock] = TRUE;
			}
		} else {
			m_cRemapCapsLockLeftCtrl.ShowWindow(SW_HIDE);
			m_cRemapLeftCtrlCapsLock.ShowWindow(SW_HIDE);
			m_cSwapEscBackQuote.ShowWindow(SW_HIDE);
			m_cRemapLeftWindowsLeftAlt.ShowWindow(SW_HIDE);
			m_cRemapLeftAltLeftWindows.ShowWindow(SW_HIDE);
			m_cRemapRightWindowsRightAlt.ShowWindow(SW_HIDE);
			m_cRemapRightAltRightWindows.ShowWindow(SW_HIDE);
			m_cRemapNonconvertLeftAlt.ShowWindow(SW_HIDE);
			m_cRemapConvertLeftAlt.ShowWindow(SW_HIDE);
			m_cRemapRightCtrlLeftAlt.ShowWindow(SW_HIDE);
			m_cUsage.ShowWindow(SW_SHOWNA);
		}
	} else {
	}
	delete[] lpData;

	// for icons in the taskbar's status area
	{
		CString szSection;
		CString szEntry;

		szEntry.LoadString(IDS_REG_ENTRY_CX);
		m_cCx.SetCheck(AfxGetApp()->GetProfileInt(szSection, szEntry, 0));

		szEntry.LoadString(IDS_REG_ENTRY_META);
		m_cM_.SetCheck(AfxGetApp()->GetProfileInt(szSection, szEntry, 0));

		szEntry.LoadString(IDS_REG_ENTRY_SHIFT);
		m_cShift.SetCheck(AfxGetApp()->GetProfileInt(szSection, szEntry, 0));

		szEntry.LoadString(IDS_REG_ENTRY_CTRL);
		m_cCtrl.SetCheck(AfxGetApp()->GetProfileInt(szSection, szEntry, 0));

		szEntry.LoadString(IDS_REG_ENTRY_ALT);
		m_cAlt.SetCheck(AfxGetApp()->GetProfileInt(szSection, szEntry, 0));
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COptionsDlg::RemapScanCode(ScanCode oldcode, ScanCode newcode, LPBYTE lpData, LPDWORD lpOffset)
{
	memmove(lpData + *lpOffset, (LPWORD)&newcode, sizeof(WORD));
	*lpOffset += sizeof(WORD);
	memmove(lpData + *lpOffset, (LPWORD)&oldcode, sizeof(WORD));
	*lpOffset += sizeof(WORD);
}

void COptionsDlg::SwapScanCode(ScanCode code1, ScanCode code2, LPBYTE lpData, LPDWORD lpOffset)
{
	RemapScanCode(code1, code2, lpData, lpOffset);
	RemapScanCode(code2, code1, lpData, lpOffset);
}

void COptionsDlg::OnOK() 
{
	// TODO: Add extra validation here
	// for auto run
	{
		TCHAR szFileName[MAX_PATH];
		ZeroMemory(szFileName, sizeof(szFileName));
		GetModuleFileName(NULL, szFileName, sizeof(szFileName));
		HKEY hKey;
		CString szSubKey;
		szSubKey.LoadString(IDS_REGSUBKEY_AUTORUN);
		CString szValueName;
		szValueName.LoadString(AFX_IDS_APP_TITLE);

		DWORD dwDisposition;
		RegCreateKeyEx(HKEY_CURRENT_USER, szSubKey, 0, NULL, REG_OPTION_NON_VOLATILE,
					   KEY_ALL_ACCESS, NULL, &hKey, &dwDisposition);

		if (m_cAutoRun.GetCheck() == 1) {
			RegSetValueEx(hKey, szValueName, 0, REG_SZ, (LPBYTE)szFileName, strlen(szFileName));
		} else {
			RegDeleteValue(hKey, szValueName);
		}

		RegCloseKey(hKey);
	}

	// for file and directory name completion
	if (IsNT()) {
		HKEY hKey;
		CString szSubKey;
		szSubKey.LoadString(IDS_REGSUBKEY_FILE_COMPLETION);
		CString szValueName;
		szValueName.LoadString(IDS_COMPLETION_CHAR);

		if (RegCreateKeyEx(HKEY_CURRENT_USER, szSubKey, 0, NULL, REG_OPTION_NON_VOLATILE,
						   KEY_SET_VALUE, NULL, &hKey, NULL) == ERROR_SUCCESS) {
			DWORD dwCompletionChar;
			if (m_cFileCompletion.GetCheck() == 1) {
				dwCompletionChar = 0x9;	// use enum
			} else {
				dwCompletionChar = 0x0;
			}
			RegSetValueEx(hKey, szValueName, 0, REG_DWORD,
						  (LPBYTE)&dwCompletionChar, sizeof(dwCompletionChar));
			RegCloseKey(hKey);
		}
	}

	// for remap keyboard
	if (ChangedRemap()) {
		enum { INDIVIDUAL_MAPPING_SIZE = 4 };
		LPBYTE	lpData		= NULL;
		DWORD	dwcbData	= 0;
		GetRegScanCode(&lpData, &dwcbData);

		if (IsNT()) {
			LPBYTE lpNewData = NULL;
			lpNewData = new BYTE[dwcbData + INDIVIDUAL_MAPPING_SIZE * 8];
			memset(lpNewData, 0, dwcbData + INDIVIDUAL_MAPPING_SIZE * 8);
			DWORD dwOffset = 12;
			DWORD dwNewOffset = 12;

			if (lpData && dwcbData) {
				for (dwOffset = dwNewOffset = 12; dwOffset < dwcbData - INDIVIDUAL_MAPPING_SIZE; dwOffset += INDIVIDUAL_MAPPING_SIZE) {
					LPWORD lpOriginalWord = (LPWORD) (lpData + dwOffset + sizeof(WORD));
					switch (*(lpOriginalWord)) {
					case SC_NA:
					case SC_ESCAPE:
					case SC_LEFT_CONTROL:
					case SC_RIGHT_CONTROL:
					case SC_BACK_QUOTE:
					case SC_LEFT_ALT:
					case SC_RIGHT_ALT:
					case SC_CAPSLOCK:
					case SC_LEFT_WINDOWS:
					case SC_RIGHT_WINDOWS:
					case SC_CONVERT:
					case SC_NONCONVERT:
						break;
					default:
						memmove(lpNewData + dwNewOffset, lpData + dwOffset, INDIVIDUAL_MAPPING_SIZE);
						dwNewOffset += INDIVIDUAL_MAPPING_SIZE;
						break;
					}
				}
			}

			if (m_cRemapCapsLockLeftCtrl.GetCheck() == 1) {
				RemapScanCode(SC_CAPSLOCK, SC_LEFT_CONTROL, lpNewData, &dwNewOffset);
			}
			if (m_cRemapLeftCtrlCapsLock.GetCheck() == 1) {
				RemapScanCode(SC_LEFT_CONTROL, SC_CAPSLOCK, lpNewData, &dwNewOffset);
			}
			if (m_cSwapEscBackQuote.GetCheck() == 1) {
				SwapScanCode(SC_ESCAPE, SC_BACK_QUOTE, lpNewData, &dwNewOffset);
			}
			if (m_cRemapLeftWindowsLeftAlt.GetCheck() == 1) {
				RemapScanCode(SC_LEFT_WINDOWS, SC_LEFT_ALT, lpNewData, &dwNewOffset);
			}
			if (m_cRemapLeftAltLeftWindows.GetCheck() == 1) {
				RemapScanCode(SC_LEFT_ALT, SC_LEFT_WINDOWS, lpNewData, &dwNewOffset);
			}
			if (m_cRemapRightWindowsRightAlt.GetCheck() == 1) {
				RemapScanCode(SC_RIGHT_WINDOWS, SC_RIGHT_ALT, lpNewData, &dwNewOffset);
			}
			if (m_cRemapRightAltRightWindows.GetCheck() == 1) {
				RemapScanCode(SC_RIGHT_ALT, SC_RIGHT_WINDOWS, lpNewData, &dwNewOffset);
			}
			if (m_cRemapNonconvertLeftAlt.GetCheck() == 1) {
				RemapScanCode(SC_NONCONVERT, SC_LEFT_ALT, lpNewData, &dwNewOffset);
			}
			if (m_cRemapConvertLeftAlt.GetCheck() == 1) {
				RemapScanCode(SC_CONVERT, SC_LEFT_ALT, lpNewData, &dwNewOffset);
			}
			if (m_cRemapRightCtrlLeftAlt.GetCheck() == 1) {
				RemapScanCode(SC_RIGHT_CONTROL, SC_LEFT_ALT, lpNewData, &dwNewOffset);
			}

			DWORD dwcbNewData = (dwNewOffset - 12) / sizeof(DWORD) + 1;
			memmove(lpNewData + 8, &dwcbNewData, sizeof(DWORD));

			SetRegScanCode(lpNewData, 12 + dwcbNewData * sizeof(DWORD));

			delete[] lpNewData;
		} else if (Is9x()) {
			if (lpData && dwcbData) {
				if (m_cRemapCapsLockLeftCtrl.GetCheck() == 1) {
					*lpData = 0x01;
				} else {
					*lpData = 0x00;
				}

				if (m_cRemapLeftCtrlCapsLock.GetCheck() == 1) {
					*(lpData + 1) = 0x00;
				} else {
					*(lpData + 1) = 0x01;
				}

				SetRegScanCode(lpData, 4);
			}
		} else {
		}
		delete[] lpData;

		// Do you want to restart computer?
		CString szText;
		szText.LoadString(IDS_RESTART_OR_NOT);
		CString szCaption;
		szCaption.LoadString(IDS_RESTART_CAPTION);
		if (MessageBox(szText, szCaption, MB_YESNO | MB_ICONQUESTION) == IDYES) {
			RestartComputer();
		}
	}

	// for icons in the taskbar's status area
	{
		// write data in registry
		CString szSection;
		CString szEntry;

		szEntry.LoadString(IDS_REG_ENTRY_CX);
		AfxGetApp()->WriteProfileInt(szSection, szEntry, m_cCx.GetCheck());

		szEntry.LoadString(IDS_REG_ENTRY_META);
		AfxGetApp()->WriteProfileInt(szSection, szEntry, m_cM_.GetCheck());

		szEntry.LoadString(IDS_REG_ENTRY_SHIFT);
		AfxGetApp()->WriteProfileInt(szSection, szEntry, m_cShift.GetCheck());

		szEntry.LoadString(IDS_REG_ENTRY_CTRL);
		AfxGetApp()->WriteProfileInt(szSection, szEntry, m_cCtrl.GetCheck());

		szEntry.LoadString(IDS_REG_ENTRY_ALT);
		AfxGetApp()->WriteProfileInt(szSection, szEntry, m_cAlt.GetCheck());

		// set dll data
		CMainFrame *pMainFrame = (CMainFrame*)AfxGetMainWnd();
		pMainFrame->m_pXkeymacsDll->EnableShell_NotifyIcon(CX_ICON, m_cCx.GetCheck());
		pMainFrame->m_pXkeymacsDll->EnableShell_NotifyIcon(META_ICON, m_cM_.GetCheck());
		pMainFrame->m_pXkeymacsDll->EnableShell_NotifyIcon(SHIFT_ICON, m_cShift.GetCheck());
		pMainFrame->m_pXkeymacsDll->EnableShell_NotifyIcon(CTRL_ICON, m_cCtrl.GetCheck());
		pMainFrame->m_pXkeymacsDll->EnableShell_NotifyIcon(ALT_ICON, m_cAlt.GetCheck());
	}

	CDialog::OnOK();
}

// Return True if Windows NT 4.0, Windows 2000, Windows XP, or Windows .NET Server.
BOOL COptionsDlg::IsNT()
{
	if (m_lpVersionInformation->dwPlatformId == VER_PLATFORM_WIN32_NT) {
		return TRUE;
	}
	return FALSE;
}

// Return True if Windows 95, Windows 98, or Windows Me. 
BOOL COptionsDlg::Is9x()
{
	if (m_lpVersionInformation->dwPlatformId == VER_PLATFORM_WIN32_WINDOWS) {
		return TRUE;
	}
	return FALSE;
}

BOOL COptionsDlg::ChangedRemap()
{
	if (m_bRemap[CapsLock_LeftCtrl] != (m_cRemapCapsLockLeftCtrl.GetCheck() == 1) ||
		m_bRemap[LeftCtrl_CapsLock] != (m_cRemapLeftCtrlCapsLock.GetCheck() == 1) ||
		m_bRemap[Esc_BackQuote] != (m_cSwapEscBackQuote.GetCheck() == 1) ||
		m_bRemap[LeftWindows_LeftAlt] != (m_cRemapLeftWindowsLeftAlt.GetCheck() == 1) ||
		m_bRemap[LeftAlt_LeftWindows] != (m_cRemapLeftAltLeftWindows.GetCheck() == 1) ||
		m_bRemap[RightWindows_RightAlt] != (m_cRemapRightWindowsRightAlt.GetCheck() == 1) ||
		m_bRemap[RightAlt_RightWindows] != (m_cRemapRightAltRightWindows.GetCheck() == 1) ||
		m_bRemap[Nonconvert_LeftAlt] != (m_cRemapNonconvertLeftAlt.GetCheck() == 1) ||
		m_bRemap[Convert_LeftAlt] != (m_cRemapConvertLeftAlt.GetCheck() == 1) ||
		m_bRemap[RightCtrl_LeftAlt] != (m_cRemapRightCtrlLeftAlt.GetCheck() == 1)) {
		return TRUE;
	}

	return FALSE;
}

void COptionsDlg::RestartComputer()
{
	if (IsNT()) {
		HANDLE TokenHandle;
		if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES, &TokenHandle)) {
			return;
		}

		TOKEN_PRIVILEGES NewState;
		NewState.PrivilegeCount = 1;
		NewState.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
		if (!LookupPrivilegeValue(NULL, SE_SHUTDOWN_NAME, &NewState.Privileges[0].Luid)) {
			return;
		}

		if (!AdjustTokenPrivileges(TokenHandle, FALSE, &NewState, 0, NULL, NULL)) {
			return;
		}
	}

	ExitWindowsEx(EWX_REBOOT, 0);
}
