// Profile.cpp: implementation of the CProfile class
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "xkeymacs.h"
#include "Profile.h"
#include "MainFrm.h"
#include <Imm.h>
#include <Shlwapi.h>	// Windows NT/2000: Requires Windows 2000 (or Windows NT 4.0 with Internet Explorer 4.0 or later). 
						// Windows 95/98/Me: Requires Windows 98 (or Windows 95 with Internet Explorer 4.0 or later). 

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#pragma data_seg(".xkmcs")
	CXkeymacsData CProfile::m_XkeymacsData[MAX_APP];
	TASK_LIST CProfile::m_TaskList[MAX_TASKS];
	DWORD CProfile::m_dwTasks;
#pragma data_seg()

enum {INITIAL_SIZE	= 51200};
enum {EXTEND_SIZE	= 25600};

void CProfile::Item2AppName(CString *sz)
{
	if (IsTheString(*sz, IDS_DEFAULT_TITLE)) {
		sz->LoadString(IDS_DEFAULT);
	}

	if (IsTheString(*sz, IDS_DIALOG_TITLE)) {
		sz->LoadString(IDS_DIALOG);
	}

	int nStart, nEnd, nCount;

	nStart	= sz->ReverseFind('(') + 1;
	nEnd	= sz->Find(')', nStart) - 1;
	nCount	= (nEnd + 1) - nStart;
	*sz		= sz->Mid(nStart, nCount);
}

int CProfile::IsNotSameString(CComboBox *pApplication, CString szListItem)
{
	CString szItem, szList;
	szList = szListItem;
	Item2AppName(&szList);

	for (int i = 0; i < pApplication->GetCount(); i++) {
		pApplication->GetLBText(i, szItem);
		Item2AppName(&szItem);
		if (!stricmp(szItem, szList)) {
			return 0;
		}
	}

	return 1;
}

int CProfile::CountSeparator(CString szMainString, CString szSeparator)
{
	int index	= 0;
	int counter	= 0;

	while ((index = szMainString.Find(szSeparator, index)) != -1) {
		index++;
		counter++;
	}

	return counter;
}

void CProfile::GetNthString(CString *szAppName, CString szWindowName, CString szSeparator, int n)
{
	int index = -1;

	while (--n) {
		index = szWindowName.Find(szSeparator, index + 1);
	}

	int nStart;
	if (index != -1) {
		nStart = index + szSeparator.GetLength();
	} else {
		nStart = 0;
	}

	int nEnd = szWindowName.Find(szSeparator, nStart);
	if (nEnd == -1) {
		nEnd = szWindowName.GetLength();
	}

	*szAppName = szWindowName.Mid(nStart, nEnd - nStart);
}

void CProfile::GetAppName(CString *szAppName, char *pWindowName)
{
	CString szWindowName(pWindowName);
	CString szSeparator;
	szSeparator.LoadString(IDS_SEPARATE_WINDOWTITLE);
	int nWord = CountSeparator(szWindowName, szSeparator) + 1;

	while (nWord) {
		GetNthString(szAppName, szWindowName, szSeparator, nWord);
		if (szAppName->GetAt(0) == '['		||
			szAppName->Find('.', 0) != -1	||	// for Microsoft Project
			szAppName->Find(']', 0) != -1) {	// for the file name like [foo - bar]
			nWord--;
		} else {
			return;
		}
	}

	*szAppName = szWindowName;
}

BOOL CALLBACK CProfile::EnumWndProc(HWND hWnd, LPARAM lParam)
{
	CComboBox		*pApplication	= (CComboBox*)lParam;
	PTASK_LIST		pTask			= CProfile::m_TaskList;
	
	char szWindowName[WINDOW_NAME_LENGTH];
	char szClassName[CLASS_NAME_LENGTH];
	WINDOWPLACEMENT wpl;
	
	wpl.length = sizeof(WINDOWPLACEMENT);
	GetWindowText(hWnd, szWindowName, sizeof(szWindowName));
	GetClassName(hWnd, szClassName, sizeof(szClassName));

	CString szAppName;
	// Get Process Name
	DWORD dwProcessId = 0;
	GetWindowThreadProcessId(hWnd, &dwProcessId);
	for (DWORD i = 0; i < CProfile::m_dwTasks; i++) {
		if (pTask[i].dwProcessId == dwProcessId) {
			CString szB2;
			szB2.LoadString(IDS_B2);
			CString szExplorer;
			szExplorer.LoadString(IDS_EXPLORER);
			CString szProject;
			szProject.LoadString(IDS_PROJECT);
			CString szExcel;
			szExcel.LoadString(IDS_EXCEL);
			CString szMSDN;
			szMSDN.LoadString(IDS_MSDN);
			CString szMsimn;
			szMsimn.LoadString(IDS_MSIMN);
			
			// Get Application Name
			if (szWindowName[0] == '\0') {
				continue;
			}
			if (strnicmp(pTask[i].ProcessName, szB2, sizeof(pTask[i].ProcessName)) &&
				strnicmp(pTask[i].ProcessName, szExplorer, sizeof(pTask[i].ProcessName)) &&
				strnicmp(pTask[i].ProcessName, szProject, sizeof(pTask[i].ProcessName)) &&
				strnicmp(pTask[i].ProcessName, szExcel, sizeof(pTask[i].ProcessName)) &&
				strnicmp(pTask[i].ProcessName, szMSDN, sizeof(pTask[i].ProcessName)) &&
				strnicmp(pTask[i].ProcessName, szMsimn, sizeof(pTask[i].ProcessName))) {
				GetAppName(&szAppName, szWindowName);
			} else if (!strnicmp(pTask[i].ProcessName, szB2, sizeof(pTask[i].ProcessName))) {
				szAppName.LoadString(IDS_BECKY);
			} else if (!strnicmp(pTask[i].ProcessName, szExplorer, sizeof(pTask[i].ProcessName))) {
				szAppName.LoadString(IDS_PROGRAM_MANAGER);
			} else if (!strnicmp(pTask[i].ProcessName, szMsimn, sizeof(pTask[i].ProcessName))) {
				szAppName.LoadString(IDS_OUTLOOK_EXPRESS);
			} else if (!strnicmp(pTask[i].ProcessName, szProject, sizeof(pTask[i].ProcessName)) ||
					   !strnicmp(pTask[i].ProcessName, szExcel, sizeof(pTask[i].ProcessName))) {
				CString szSeparator;
				szSeparator.LoadString(IDS_SEPARATE_WINDOWTITLE);
				GetNthString(&szAppName, szWindowName, szSeparator, 1);
			} else if (!strnicmp(pTask[i].ProcessName, szMSDN, sizeof(pTask[i].ProcessName))) {
				szAppName = szWindowName;
			} else {
				szAppName.LoadString(IDS_UNKNOWN_APPLICATION);
			}
			break;
		}
	}
	
	
	if ((IsWindowVisible(hWnd)) &&								// Is visible?
		(GetWindow(hWnd, GW_OWNER) == NULL) &&					// Is top level window?
		(lstrlen(szWindowName) > 0) &&							// Have caption?
		(pApplication->FindString(-1, szClassName) == CB_ERR)) {// Is not same string?
		CString szListItem;
//		szListItem.Format(IDS_APPLICATION_LIST_ITEM, szClassName, szWindowName);		
		szListItem.Format(IDS_APPLICATION_LIST_ITEM, szAppName, pTask[i].ProcessName);
		if (IsNotSameString(pApplication, szListItem)) {
			pApplication->AddString(szListItem);
		}
	}
	return TRUE;
}

	
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CProfile::CProfile()
{

}

CProfile::~CProfile()
{

}

// This method initializes data in the registry, or retrieves and validates registry data.
// bSaveAndValidate specifies a flag that indicates 
// whether registry data is being initialized (FALSE) or data is being retrieved (TRUE). 
void CProfile::UpdateRegistryData(BOOL bSaveAndValidate)
{
	CString szEntry;
	CString szApplicationName;
	CString szApplicationTitle;

	BOOL bUseDialogSetting = FALSE;

	for (int nApplicationID = 0; nApplicationID < MAX_APP; nApplicationID++) {
		// application name
		CString szSection;
		szSection.LoadString(IDS_REG_SECTION_APPLICATION);
		szEntry.Format(IDS_REG_ENTRY_APPLICATION, nApplicationID);
		if (bSaveAndValidate) {	// retrieve
			m_XkeymacsData[nApplicationID].ClearAll();
			szApplicationName = AfxGetApp()->GetProfileString(szSection, szEntry);
			if (szApplicationName.IsEmpty()) {
				if (nApplicationID) {
					if (!bUseDialogSetting) {
						szApplicationName.LoadString(IDS_DIALOG);
						bUseDialogSetting = TRUE;
					} else {
						continue;
					}
				} else {
					szApplicationName.LoadString(IDS_DEFAULT);
				}
			} else {
				CString szDialog;
				szDialog.LoadString(IDS_DIALOG);
				if (szApplicationName == szDialog) {
					bUseDialogSetting = TRUE;
				}
			}
			m_XkeymacsData[nApplicationID].SetApplicationName(szApplicationName);
		} else {				// initialize
			szApplicationName = m_XkeymacsData[nApplicationID].GetApplicationName();
			if (szApplicationName.IsEmpty()) {
				continue;
			}
			AfxGetApp()->WriteProfileString(szSection, szEntry, szApplicationName);
		}

		// application title
		szEntry.LoadString(IDS_REG_ENTRY_APPLICATOIN_TITLE);
		if (bSaveAndValidate) {	// retrieve
			szApplicationTitle = AfxGetApp()->GetProfileString(szApplicationName, szEntry);
			m_XkeymacsData[nApplicationID].SetApplicationTitle(szApplicationTitle);
		} else {				// initialize
			szApplicationTitle = m_XkeymacsData[nApplicationID].GetApplicationTitle();
			while (!szApplicationTitle.IsEmpty() && szApplicationTitle.GetAt(0) == ' ') {
				szApplicationTitle.Delete(0);
			}
			AfxGetApp()->WriteProfileString(szApplicationName, szEntry, szApplicationTitle);
		}

		// on/off
		if (bSaveAndValidate) {	// retrieve
			for (int nCommandID = 1; ; nCommandID++) {
				szEntry = CXkeymacsData::GetCommandName(nCommandID);
				if (szEntry.IsEmpty()) {
					break;
				}

				HKEY hKey = 0;
				CString szSubKey;
				szSubKey.LoadString(IDS_REGSUBKEY_DATA);
				szSubKey += "\\" + szApplicationName + "\\" + szEntry;
				if (RegOpenKeyEx(HKEY_CURRENT_USER, szSubKey, 0, KEY_READ, &hKey) == ERROR_SUCCESS) {
					// Use registry data
					char szKeyBind[128] = {'\0'};
					DWORD dwKeyBind = sizeof(szKeyBind);
					FILETIME ft = {'\0'};	// not use
					for (DWORD dwIndex = 0;
						 RegEnumKeyEx(hKey, dwIndex, szKeyBind, &dwKeyBind, NULL, NULL, NULL, &ft) == ERROR_SUCCESS;
						 dwIndex++) {
						int nCommandType = 0;
						int nKey = 0;
						ReadKeyBind(&nCommandType, &nKey, szKeyBind);
						m_XkeymacsData[nApplicationID].SetCommandID(nCommandType, nKey, nCommandID);

						memset(szKeyBind, 0, sizeof(szKeyBind));
						dwKeyBind = sizeof(szKeyBind);
					}
					RegCloseKey(hKey);
				} else {
					// Use default setting
					for (int i = 0; ; i++) {
						if (CXkeymacsData::GetDefaultControlID(nCommandID, i) == IDC_CO2) {
							continue;
						}

						int nCommandType = CXkeymacsData::GetDefaultCommandType(nCommandID, i);
						int nKey = CXkeymacsData::GetDefaultCommandKey(nCommandID, i);
						if (nKey == 0) {
							break;
						}
						m_XkeymacsData[nApplicationID].SetCommandID(nCommandType, nKey, nCommandID);
					}
				}
			}
		} else {				// initialize
			// create all commands
			for (int nCommandID = 1; ; nCommandID++) {
				szEntry = CXkeymacsData::GetCommandName(nCommandID);
				if (szEntry.IsEmpty()) {
					break;
				}

				HKEY hKey = 0;
				CString szSubKey;
				szSubKey.LoadString(IDS_REGSUBKEY_DATA);
				szSubKey += "\\" + szApplicationName + "\\" + szEntry;

				RegCreateKeyEx(HKEY_CURRENT_USER, szSubKey, 0, NULL, REG_OPTION_NON_VOLATILE,
							   KEY_ALL_ACCESS, NULL, &hKey, NULL);
				RegCloseKey(hKey);
			}
			for (int nCommandType = 0; nCommandType < MAX_COMMAND_TYPE; nCommandType++) {
				for (int nKey = 0; nKey < MAX_KEY; nKey++) {
					int nCommandID = m_XkeymacsData[nApplicationID].GetCommandID(nCommandType, nKey);
					if (!nCommandID) {
						continue;
					}
					szEntry = CXkeymacsData::GetCommandName(nCommandID);
					char szKeyBind[128] = {'\0'};
					WriteKeyBind(nCommandType, nKey, szKeyBind, sizeof(szKeyBind));
					HKEY hKey = 0;
					CString szSubKey;
					szSubKey.LoadString(IDS_REGSUBKEY_DATA);
					szSubKey += "\\" + szApplicationName + "\\" + szEntry + "\\" + szKeyBind;
					RegCreateKeyEx(HKEY_CURRENT_USER, szSubKey, 0, NULL, REG_OPTION_NON_VOLATILE,
								   KEY_ALL_ACCESS, NULL, &hKey, NULL);
					RegCloseKey(hKey);
				}
			}
		}

		// kill-ring-max
		szEntry.LoadString(IDS_REG_ENTRY_KILL_RING_MAX);
		if (bSaveAndValidate) {	// retrieve
			int nKillRingMax = AfxGetApp()->GetProfileInt(szApplicationName, szEntry, 0);
			m_XkeymacsData[nApplicationID].SetKillRingMax(nKillRingMax);
		} else {				// initialize
			int nKillRingMax = m_XkeymacsData[nApplicationID].GetKillRingMax();
			AfxGetApp()->WriteProfileInt(szApplicationName, szEntry, nKillRingMax);
		}

		// Use Dialog Setting
		szEntry.LoadString(IDS_REG_ENTRY_USE_DIALOG_SETTING);
		if (bSaveAndValidate) {	// retrieve
			BOOL bUseDialogSetting = AfxGetApp()->GetProfileInt(szApplicationName,szEntry, 1);
			m_XkeymacsData[nApplicationID].SetUseDialogSetting(bUseDialogSetting);
		} else {				// initialize
			BOOL bUseDialogSetting = m_XkeymacsData[nApplicationID].GetUseDialogSetting();
			AfxGetApp()->WriteProfileInt(szApplicationName, szEntry, bUseDialogSetting);
		}

		// Setting Style
		szEntry.LoadString(IDS_REG_ENTRY_DISABLE_XKEYMACS);
		if (bSaveAndValidate) {	// retrieve
			int nSettingStyle = SETTING_SPECIFIC;
			if (AfxGetApp()->GetProfileInt(szApplicationName, szEntry, 0) != 0) {
				nSettingStyle = SETTING_DISABLE;
			}
			m_XkeymacsData[nApplicationID].SetSettingStyle(nSettingStyle);
		} else {				// initialize
			BOOL bDisableXkeymacs = FALSE;
			if (m_XkeymacsData[nApplicationID].GetSettingStyle() == SETTING_DISABLE) {
				bDisableXkeymacs = TRUE;
			}
			AfxGetApp()->WriteProfileInt(szApplicationName, szEntry, bDisableXkeymacs);
		}

		// Ignore Meta Ctrl+? when it is undefined.
		szEntry.LoadString(IDC_REG_ENTRY_IGNORE_META_CTRL);
		if (bSaveAndValidate) {	// retrieve
			m_XkeymacsData[nApplicationID].SetIgnoreUndefinedMetaCtrl(AfxGetApp()->GetProfileInt(szApplicationName, szEntry, 0));
		} else {				// initialize
			AfxGetApp()->WriteProfileInt(szApplicationName, szEntry, m_XkeymacsData[nApplicationID].GetIgnoreUndefinedMetaCtrl());
		}

		// Ignore C-x ? when it is undefined.
		szEntry.LoadString(IDC_REG_ENTRY_IGNORE_C_X);
		if (bSaveAndValidate) {	// retrieve
			m_XkeymacsData[nApplicationID].SetIgnoreUndefinedC_x(AfxGetApp()->GetProfileInt(szApplicationName, szEntry, 0));
		} else {				// initialize
			AfxGetApp()->WriteProfileInt(szApplicationName, szEntry, m_XkeymacsData[nApplicationID].GetIgnoreUndefinedC_x());
		}
	}
}

void CProfile::LoadRegistryData()
{
	UpdateRegistryData(TRUE);
}

void CProfile::SaveRegistryData()
{
	DeleteAllRegistryData();
	UpdateRegistryData(FALSE);
	SetDllData();
}

void CProfile::SetDllData()
{
	CMainFrame *pMainFrame = (CMainFrame*)AfxGetMainWnd();

	for (int nApplicationID = 0; nApplicationID < MAX_APP; nApplicationID++) {

		CString szApplicationName = m_XkeymacsData[nApplicationID].GetApplicationName();

		if (szApplicationName.IsEmpty()) {
			pMainFrame->m_pXkeymacsDll->Clear(nApplicationID);
			continue;
		}

		pMainFrame->m_pXkeymacsDll->SetApplicationName(nApplicationID, szApplicationName);
		pMainFrame->m_pXkeymacsDll->SetCommandID(nApplicationID, CONTROL, 'X', 0);
		pMainFrame->m_pXkeymacsDll->SetCommandID(nApplicationID, CONTROL+SHIFT, 'X', 0);

		for (int nCommandType = 0; nCommandType < MAX_COMMAND_TYPE; nCommandType++) {
			for (int nKey = 0; nKey < MAX_KEY; nKey++) {
				int nCommandID = m_XkeymacsData[nApplicationID].GetCommandID(nCommandType, nKey);
				pMainFrame->m_pXkeymacsDll->SetCommandID(nApplicationID, nCommandType, nKey, nCommandID);
				if ((nCommandType & CONTROLX) && nCommandID) {
					pMainFrame->m_pXkeymacsDll->SetCommandID(nApplicationID, CONTROL, 'X', 1);			// Commands[1] is C-x
					pMainFrame->m_pXkeymacsDll->SetCommandID(nApplicationID, CONTROL+SHIFT, 'X', 1);
				}
			}
		}

		pMainFrame->m_pXkeymacsDll->SetKillRingMax(nApplicationID, m_XkeymacsData[nApplicationID].GetKillRingMax());
		pMainFrame->m_pXkeymacsDll->SetUseDialogSetting(nApplicationID, m_XkeymacsData[nApplicationID].GetUseDialogSetting());
		pMainFrame->m_pXkeymacsDll->SetSettingStyle(nApplicationID, m_XkeymacsData[nApplicationID].GetSettingStyle());
		pMainFrame->m_pXkeymacsDll->SetIgnoreUndefinedMetaCtrl(nApplicationID, m_XkeymacsData[nApplicationID].GetIgnoreUndefinedMetaCtrl());
		pMainFrame->m_pXkeymacsDll->SetIgnoreUndefinedC_x(nApplicationID, m_XkeymacsData[nApplicationID].GetIgnoreUndefinedC_x());
	}
}

void CProfile::ReadKeyBind(int *pnCommandType, int *pnKey, char *szKeyBind)
{
	*pnCommandType = KeyBind2CommandType(szKeyBind);
	*pnKey = KeyBind2Key(szKeyBind + strlen(CommandType2String(*pnCommandType)));
}

void CProfile::WriteKeyBind(int nCommandType, int nKey, char *szKeyBind, int nKeyBindLength)
{
	memset(szKeyBind, 0, nKeyBindLength);

	char *pCommandType	= CommandType2String(nCommandType);
	char *pKey			= Key2String(nKey);
	if (!pCommandType || !pKey) {
		return;
	}

	sprintf(szKeyBind, "%s%s", pCommandType, pKey);
}

int CProfile::KeyBind2CommandType(char *szKeyBind)
{
	for (int nCommandType = MAX_COMMAND_TYPE - 1; nCommandType; nCommandType--) {
		if (IsCommandType(nCommandType, szKeyBind)) {
			return nCommandType;
		}
	}
	return NONE;
}

int CProfile::KeyBind2Key(char *szKey)
{
	for (int nKey = 1; nKey < 0xff; nKey++) {
		if (!strcmp(szKey, Key2String(nKey))) {
			return nKey;
		}
	}
	return 0;
}

char * CProfile::CommandType2String(int nCommandType)
{
	return CommandTypes[nCommandType].szCommandTypeName;
}

char * CProfile::Key2String(int nKey)
{
	return KeyNames[nKey].szKeyName;
}

BOOL CProfile::IsCommandType(int nCommandType, char *szKeyBind)
{
	char *szCommandType = CommandType2String(nCommandType);

	if (!strnicmp(szKeyBind, szCommandType, strlen(szCommandType))) {
		return TRUE;
	}

	return FALSE;
}

void CProfile::InitDllData()
{
	LoadRegistryData();
	SetDllData();
}

void CProfile::ClearData(CString szCurrentApplication)
{
	for (int nApplicationID = 0; nApplicationID < MAX_APP; nApplicationID++) {
		if (m_XkeymacsData[nApplicationID].GetApplicationName() == szCurrentApplication) {
			break;
		}
	}
	if (nApplicationID < MAX_APP) {
		m_XkeymacsData[nApplicationID].ClearAll();
	}
}

// return count of saved settings
int CProfile::GetSavedSettingCount()
{
	int nSavedSetting = 0;

	for (int nApplicationID = 0; nApplicationID < MAX_APP; nApplicationID++) {
		CString szApplicationName;
		szApplicationName = m_XkeymacsData[nApplicationID].GetApplicationName();
		if (!szApplicationName.IsEmpty()) {
			nSavedSetting++;
		}
	}

	return nSavedSetting;
}

void CProfile::InitApplicationList(CComboBox *cApplicationList)
{
	cApplicationList->ResetContent();

	m_dwTasks = GetTaskList(m_TaskList, MAX_TASKS);

	EnumWindows(EnumWndProc, (LPARAM)cApplicationList);

	for (int i = 0; i < MAX_APP; i++) {
		CString szApplicationName	= m_XkeymacsData[i].GetApplicationName();
		CString szApplicationTitle	= m_XkeymacsData[i].GetApplicationTitle();

		CString szListItem;
		szListItem.Format(IDS_APPLICATION_LIST_ITEM, szApplicationTitle, szApplicationName);
		if (IsNotSameString(cApplicationList, szListItem) &&
			!IsDefault(szApplicationName) &&
			!IsDialog(szApplicationName) &&
			!szApplicationName.IsEmpty()) {
			cApplicationList->AddString(szListItem);
		}
	}

	// Add IME
	HKL hKL = GetKeyboardLayout(0);
	if (ImmIsIME(hKL)) {
		char szDummy;

		UINT nIMEDescription = ImmGetDescription(hKL, &szDummy, 0);
		nIMEDescription += sizeof(char);	// for NULL
		char *szIMEDescription = new char[nIMEDescription];
		ImmGetDescription(hKL, szIMEDescription, nIMEDescription);

		UINT nIMEFileName = ImmGetIMEFileName(hKL, &szDummy, 0);
		nIMEFileName += sizeof(char);
		char *szIMEFileName = new char[nIMEFileName];
		ImmGetIMEFileName(hKL, szIMEFileName, nIMEFileName);

		CString szIMETitle;
		szIMETitle.Format(IDS_APPLICATION_LIST_ITEM, szIMEDescription, szIMEFileName);
		if (IsNotSameString(cApplicationList, szIMETitle) &&
			(nIMEDescription || nIMEFileName)) {
			cApplicationList->AddString(szIMETitle);
		}

		delete[] szIMEDescription;
		delete[] szIMEFileName;
	}

	// Add Dialog
	CString szDialogTitle;
	szDialogTitle.LoadString(IDS_DIALOG_TITLE);
	cApplicationList->InsertString(0, szDialogTitle);

	// Add Default
	CString szDefaultTitle;
	szDefaultTitle.LoadString(IDS_DEFAULT_TITLE);
	cApplicationList->InsertString( 0, szDefaultTitle);
	cApplicationList->SelectString(-1, szDefaultTitle);
}

DWORD CProfile::GetTaskList(PTASK_LIST pTask, DWORD dwNumTasks)
{
	for (int i = 0; i < MAX_TASKS; i++) {
		ZeroMemory(&pTask[i], sizeof(PTASK_LIST));
	}

	OSVERSIONINFO verInfo = {0};
	verInfo.dwOSVersionInfoSize = sizeof (verInfo);
	GetVersionEx(&verInfo);
	if (verInfo.dwPlatformId == VER_PLATFORM_WIN32_NT &&
		verInfo.dwMajorVersion < 5) {
		return GetTaskListNT(pTask, dwNumTasks);
	}

	HMODULE hKernel = GetModuleHandle("KERNEL32.DLL");
	if (!hKernel) {
		return 0;
	}

	CREATESNAPSHOT pCreateToolhelp32Snapshot = (CREATESNAPSHOT)GetProcAddress(hKernel, "CreateToolhelp32Snapshot");
	if (!pCreateToolhelp32Snapshot) {
		return 0;
	}

	PROCESSWALK pProcess32First = (PROCESSWALK)GetProcAddress(hKernel, "Process32First");
	if (!pProcess32First) {
		return 0;
	}

	PROCESSWALK pProcess32Next = (PROCESSWALK)GetProcAddress(hKernel, "Process32Next");
	if (!pProcess32Next) {
		return 0;
	}

	HANDLE hProcessSnap = pCreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	if (hProcessSnap == (HANDLE)-1) {
		return 0;
	}

	DWORD dwTaskCount = 0;
	PROCESSENTRY32 processEntry32 = {sizeof(PROCESSENTRY32)};
	if (pProcess32First(hProcessSnap, &processEntry32)) {
		do {
			LPSTR pCurChar;
			for (pCurChar = processEntry32.szExeFile + lstrlen(processEntry32.szExeFile); *pCurChar != '\\' && pCurChar != processEntry32.szExeFile; --pCurChar) {
				;
			}
			if (*pCurChar == '\\') {
				pCurChar++;
			}

			lstrcpy(pTask->ProcessName, pCurChar);
			pTask->dwProcessId = processEntry32.th32ProcessID;

			++dwTaskCount;
			++pTask;
		} while (dwTaskCount < dwNumTasks && pProcess32Next(hProcessSnap, &processEntry32));
	}

	CloseHandle(hProcessSnap);
	return dwTaskCount;
}

LPBYTE CProfile::GetCounters()
{
	CString szRegsubkeyPere;
	szRegsubkeyPere.LoadString(IDS_REGSUBKEY_PERF);
	LANGID lid = MAKELANGID(LANG_ENGLISH, SUBLANG_NEUTRAL);
	CString szSubKey;
	szSubKey.Format(szRegsubkeyPere, lid);
	HKEY hKey = 0;
	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, szSubKey, 0, KEY_READ, &hKey) != ERROR_SUCCESS) {
		return NULL;
	}

	szSubKey.LoadString(IDS_REGSUBKEY_COUNTERS);
	DWORD dwSize = 0;
	if (RegQueryValueEx(hKey, szSubKey, NULL, NULL, NULL, &dwSize) != ERROR_SUCCESS) {
		RegCloseKey(hKey);
		return NULL;
	}
	LPBYTE pCounters = (LPBYTE) calloc(dwSize, sizeof(BYTE));
	if (pCounters == NULL) {
		RegCloseKey(hKey);
		return NULL;
	}
	if (RegQueryValueEx(hKey, szSubKey, NULL, NULL, pCounters, &dwSize) != ERROR_SUCCESS) {
		RegCloseKey(hKey);
		free(pCounters);
		return NULL;
	}
	RegCloseKey(hKey);
	return pCounters;
}

BOOL CProfile::GetProcessInfo(CString *szProcessName, DWORD *dwProcessId)
{
	LPBYTE pCounters = GetCounters();
	if (!pCounters) {
		return FALSE;
	}
	LPSTR pTopOfString = (LPSTR)pCounters;
	while (*pTopOfString) {
		CString szProcess;
		szProcess.LoadString(IDS_PROCESS);
		CString szProcessId;
		szProcessId.LoadString(IDS_PROCESSID);

		if (stricmp(pTopOfString, szProcess) == 0) {
			for (LPSTR p2 = pTopOfString - 2; isdigit(*p2); p2--) {
				;
			}
			szProcessName->Format("%s", p2 + 1);	// 230
		} else if (stricmp(pTopOfString, szProcessId) == 0) {
			for (LPSTR p2 = pTopOfString - 2; isdigit(*p2); p2--) {
				;
			}
			*dwProcessId = atol(p2 + 1);			// 784
		}
		pTopOfString += (strlen(pTopOfString) + 1);
	}
	free(pCounters);
	return TRUE;
}

PPERF_DATA_BLOCK CProfile::GetPerformanceData(CString szProcessName)
{
	DWORD dwSize = INITIAL_SIZE;
	PPERF_DATA_BLOCK pPerformanceData = (PPERF_DATA_BLOCK) calloc(dwSize, sizeof(BYTE));
	if (pPerformanceData == NULL) {
		return NULL;
	}

	for (;;) {
		switch (RegQueryValueEx(HKEY_PERFORMANCE_DATA, szProcessName, NULL, NULL, (LPBYTE)pPerformanceData, &dwSize)) {
		case ERROR_SUCCESS:
			if (0 < dwSize &&
				pPerformanceData->Signature[0] == (WCHAR)'P' &&
				pPerformanceData->Signature[1] == (WCHAR)'E' &&
				pPerformanceData->Signature[2] == (WCHAR)'R' &&
				pPerformanceData->Signature[3] == (WCHAR)'F') {
				return pPerformanceData;
			}
		case ERROR_MORE_DATA:
			dwSize += EXTEND_SIZE;
			pPerformanceData = (PPERF_DATA_BLOCK) realloc(pPerformanceData, dwSize);
			if (!pPerformanceData) {
				return NULL;
			}
			memset(pPerformanceData, 0, dwSize);
			break;
		default:
			free(pPerformanceData);
			return NULL;
		}
	}
}

// Add running application's names to the list
// only for _Windows NT_
DWORD CProfile::GetTaskListNT(PTASK_LIST pTask, DWORD dwNumTasks)
{
	CString szProcessName;
	DWORD dwProcessIdTitle = 0;
	if (!GetProcessInfo(&szProcessName, &dwProcessIdTitle)) {
		return dwNumTasks;
	}

	PPERF_DATA_BLOCK pPerformanceData = GetPerformanceData(szProcessName);
	if (!pPerformanceData) {
		return dwNumTasks;
	}

	PPERF_OBJECT_TYPE pObj = (PPERF_OBJECT_TYPE) ((DWORD)pPerformanceData + pPerformanceData->HeaderLength);
	PPERF_COUNTER_DEFINITION pCounterDef = (PPERF_COUNTER_DEFINITION) ((DWORD)pObj + pObj->HeaderLength);
	DWORD dwProcessIdCounter = 0;
	for (DWORD i = 0; i < pObj->NumCounters; i++) {
		if (pCounterDef->CounterNameTitleIndex == dwProcessIdTitle) {
			dwProcessIdCounter = pCounterDef->CounterOffset;
			break;
		}
		pCounterDef++;
	}

	dwNumTasks = min(dwNumTasks - 1, (DWORD)pObj->NumInstances);
	PPERF_INSTANCE_DEFINITION pInst = (PPERF_INSTANCE_DEFINITION) ((DWORD)pObj + pObj->DefinitionLength);
	for (i = 0; i < dwNumTasks; i++) {
		LPSTR pProcessName = (LPSTR) ((DWORD)pInst + pInst->NameOffset);

		CHAR szProcessName[MAX_PATH] = {'\0'};
		if (!WideCharToMultiByte(CP_ACP, 0, (LPCWSTR)pProcessName, -1, szProcessName, sizeof(szProcessName), NULL, NULL)) {
			CString szUnknownTask;
			szUnknownTask.LoadString(IDS_UNKNOWN_TASK);
			strcpy(pTask->ProcessName, szUnknownTask);
		}

		if (strlen(szProcessName)+4 <= sizeof(pTask->ProcessName)) {
			CString szExe;
			szExe.LoadString(IDS_EXTENSION_EXECUTABLE);
			strcpy(pTask->ProcessName, szProcessName);
			strcat(pTask->ProcessName, szExe);
		}

		PPERF_COUNTER_BLOCK pCounter = (PPERF_COUNTER_BLOCK) ((DWORD)pInst + pInst->ByteLength);
		pTask->dwProcessId = *((LPDWORD) ((DWORD)pCounter + dwProcessIdCounter));
		if (pTask->dwProcessId == 0) {
			pTask->dwProcessId = (DWORD) -2;
		}

		pTask++;
		pInst = (PPERF_INSTANCE_DEFINITION) ((DWORD)pCounter + pCounter->ByteLength);
	}

	free(pPerformanceData);
	return dwNumTasks;
}

// return application index
// and update setting style
// if there is NOT the application in the data, this function takes care of it.
int CProfile::GetApplicationIndex(CString szApplicationName, BOOL bSaveAndValidate, int *nSettingStyle)
{
	if (!bSaveAndValidate) {	// SetDialogData
		*nSettingStyle = SETTING_UNDEFINED;
	}

	int nApplicationID = GetApplicationIndex(szApplicationName);

	if (nApplicationID == MAX_APP) {
		if (bSaveAndValidate) {	// GetDialogData
			for (nApplicationID = 0; nApplicationID < MAX_APP; nApplicationID++) {
				CString sz = m_XkeymacsData[nApplicationID].GetApplicationName();
				if (sz.IsEmpty()) {
					m_XkeymacsData[nApplicationID].SetApplicationName(szApplicationName);
					break;
				}
			}
			if (nApplicationID == MAX_APP) {
				return nApplicationID;
			}
		} else {				// SetDialogData
			for (nApplicationID = 0; nApplicationID < MAX_APP; nApplicationID++) {
				if (IsDefault(m_XkeymacsData[nApplicationID].GetApplicationName())) {
					*nSettingStyle = SETTING_DEFAULT;
					break;
				}
			}
			if (nApplicationID == MAX_APP) {
				return nApplicationID;
			}
		}
	}

	if (bSaveAndValidate) {	// GetDialogData
		m_XkeymacsData[nApplicationID].SetSettingStyle(*nSettingStyle);
	} else {				// SetDialogData
		if (*nSettingStyle == SETTING_UNDEFINED) {	// It means that *nSettingStyle != SETTING_DEFAULT.
			*nSettingStyle = m_XkeymacsData[nApplicationID].GetSettingStyle();
		}
	}

	return nApplicationID;
}

BOOL CProfile::IsTheString(CString sz, UINT nID)
{
	CString szDefault;
	szDefault.LoadString(nID);

	if (szDefault == sz) {
		return TRUE;
	}

	return FALSE;
}

// if sz is "Default", return TRUE
BOOL CProfile::IsDefault(CString sz)
{
	return IsTheString(sz, IDS_DEFAULT);
}

// if sz is "Dialog", return TRUE
BOOL CProfile::IsDialog(CString sz)
{
	return IsTheString(sz, IDS_DIALOG);
}

void CProfile::GetApplicationTitle(CComboBox *cApplicationList, CString &rList, int nIndex)
{
	if (0 <= nIndex) {
		cApplicationList->GetLBText(nIndex, rList);
	} else {
		cApplicationList->GetWindowText(rList);
	}

	if (IsTheString(rList, IDS_DEFAULT_TITLE)) {
		rList.LoadString(IDS_DEFAULT);
	}

	if (IsTheString(rList, IDS_DIALOG_TITLE)) {
		rList.LoadString(IDS_DIALOG);
	}

	return;
}

void CProfile::UpdateApplicationTitle(CComboBox *cApplicationList, CString szCurrentApplication, int nApplicationID, BOOL bSaveAndValidate)
{
	static CString szApplicationTitle;
	if (bSaveAndValidate) {	// GetDialogData
		if (!CProfile::IsDefault(szCurrentApplication)) {
			m_XkeymacsData[nApplicationID].SetApplicationTitle(szApplicationTitle);
		}
		szApplicationTitle.Empty();
	} else {				// SetDialogData
		CString szListItem;
		CProfile::GetApplicationTitle(cApplicationList, szListItem);
		int nEndTitle = szListItem.ReverseFind('(');
		if (nEndTitle > 0) {
			szApplicationTitle = szListItem.Left(nEndTitle);
		}
	}
}

void CProfile::SetCommandID(int nApplicationID, int nCommandType, int nKey, int nCommandID)
{
	m_XkeymacsData[nApplicationID].SetCommandID(nCommandType, nKey, nCommandID);
}

int CProfile::GetCommandID(int nApplicationID, int nCommandType, int nKey)
{
	return m_XkeymacsData[nApplicationID].GetCommandID(nCommandType, nKey);
}

void CProfile::SetKillRingMax(int nApplicationID, int nKillRingMax)
{
	m_XkeymacsData[nApplicationID].SetKillRingMax(nKillRingMax);
}

int CProfile::GetKillRingMax(int nApplicationID)
{
	return m_XkeymacsData[nApplicationID].GetKillRingMax();
}

void CProfile::SetUseDialogSetting(int nApplicationID, BOOL bUseDialogSetting)
{
	m_XkeymacsData[nApplicationID].SetUseDialogSetting(bUseDialogSetting);
}

BOOL CProfile::GetUseDefaultSetting(int nApplicationID)
{
	return m_XkeymacsData[nApplicationID].GetUseDialogSetting();
}

void CProfile::DeleteAllRegistryData()
{
	HKEY hkey;
	CString szSubKey;
	szSubKey.LoadString(IDS_REGSUBKEY_DATA);
	VERIFY(RegOpenKeyEx(HKEY_CURRENT_USER, szSubKey, 0, KEY_ALL_ACCESS, &hkey) == ERROR_SUCCESS);

	// I am sure that I have to do only one time, but...
	for (int nApplicationID = 0; nApplicationID < MAX_APP; nApplicationID++) {
		DWORD dwIndex = 0;
		char szName[SUB_KEY_NAME_LENGTH];
		DWORD dwName = sizeof(szName);
		ZeroMemory(szName, sizeof(szName));
		FILETIME filetime;

		while (RegEnumKeyEx(hkey, dwIndex, szName, &dwName, NULL, NULL, NULL, &filetime) == ERROR_SUCCESS) {
//			VERIFY(RegDeleteKey(hkey, szName) == ERROR_SUCCESS);
			VERIFY(SHDeleteKey(hkey, szName) == ERROR_SUCCESS);
			ZeroMemory(szName, sizeof(szName));
			dwName = sizeof(szName);
		}
	}

	VERIFY(RegCloseKey(hkey) == ERROR_SUCCESS);
}

int CProfile::GetCurrentApplicationID(CComboBox *cApplicationList, CString szCurrentApplication)
{
	int nCounter = cApplicationList->GetCount();
	CString szListItem;
	int nCurSel = cApplicationList->GetCurSel();

	for (int i = 0; i < nCounter; i++) {
		cApplicationList->SetCurSel(i);
		CProfile::GetApplicationTitle(cApplicationList, szListItem);
		if (szListItem.Find(szCurrentApplication) != -1) {
			cApplicationList->SetCurSel(nCurSel);
			return i;
		}
	}
	return -1;
}

void CProfile::CopyData(CString szDestinationApplication, CString szSourceApplication)
{
	int nSettingStyle = SETTING_SPECIFIC;
	int nDestinationApplication = GetApplicationIndex(szDestinationApplication, TRUE, &nSettingStyle);
	int nSourceApplication = GetApplicationIndex(szSourceApplication);

	CString szApplicationName = m_XkeymacsData[nDestinationApplication].GetApplicationName();
	CString szApplicationTitle = m_XkeymacsData[nDestinationApplication].GetApplicationTitle();

	m_XkeymacsData[nDestinationApplication] = m_XkeymacsData[nSourceApplication];

	m_XkeymacsData[nDestinationApplication].SetApplicationName(szApplicationName);
	m_XkeymacsData[nDestinationApplication].SetApplicationTitle(szApplicationTitle);
}

// return application index
// if there is NOT the application in the data, return MAX_APP
int CProfile::GetApplicationIndex(CString szApplicationName)
{
	int nApplicationID = 0;
	for (nApplicationID = 0; nApplicationID < MAX_APP; nApplicationID++) {
		if (m_XkeymacsData[nApplicationID].GetApplicationName() == szApplicationName) {
			break;
		}
	}
	return nApplicationID;
}
