// Utils.cpp: implementation of the CUtils class
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Utils.h"
#include <Imm.h>
#pragma data_seg(".xkmcs")
char CUtils::m_szApplicationName[MAX_PATH] = {'\0'};
char CUtils::m_szIMEName[MAX_PATH] = {'\0'};
OSVERSIONINFO CUtils::m_OsVersionInfo = {sizeof(OSVERSIONINFO)};
#pragma data_seg()

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CUtils::CUtils()
{

}

CUtils::~CUtils()
{

}

void CUtils::GetFindDialogTitle(CString *szDialogTitle)
{
	{
		char buf[0x100] = {'\0'};
		GetWindowText(GetForegroundWindow(), buf, sizeof(buf));
		szDialogTitle->Format("%s", buf);
	}

	if (!szDialogTitle->Compare("") ||					// notepad, wordpad, IE, regedit, 
															// Excel, Front Page, PowerPoint, Acrobat Reader, IBM HPB
		!szDialogTitle->Compare("Find") ||					// notepad, Outlook, Outlook Express, Opera
		!szDialogTitle->Compare("Find in this Page") ||		// Mozilla
		!szDialogTitle->Compare("{") ||			// Becky!
		!szDialogTitle->Compare("[") ||			// Becky!
		!szDialogTitle->Compare("̌") ||			// M$ VC++
		!szDialogTitle->Compare("ƒu") ||			// M$ Word, 123
		!szDialogTitle->Compare("̃eLXǧ") ||	// Lotus Notes
		!szDialogTitle->Compare("̃y[W")	||		// Netscape 6
		!szDialogTitle->Compare("u") ||
		!szDialogTitle->Compare("Replace")
		) {
		// do nothing
	} else {
		szDialogTitle->Empty();
	}

	return;
}

BOOL CUtils::IsAstecX()
{
	return !stricmp(m_szApplicationName, "astecx.exe");
}

BOOL CUtils::IsBecky()
{
	return !stricmp(m_szApplicationName, "b2.exe");
}

BOOL CUtils::IsEmacs()
{
	return !stricmp(m_szApplicationName, "Emacs.exe");
}

BOOL CUtils::IsExplorer()
{
	return !stricmp(m_szApplicationName, "explorer.exe");
}

BOOL CUtils::IsHidemaru()
{
	return !stricmp(m_szApplicationName, "hidemaru.exe");
}

BOOL CUtils::IsInternetExplorer()
{
	return !stricmp(m_szApplicationName, "iexplore.exe");
}

BOOL CUtils::IsLotus123()
{
	return !stricmp(m_szApplicationName, "123w.exe");
}

BOOL CUtils::IsLotusNotes()
{
	return !stricmp(m_szApplicationName, "nlnotes.exe");
}

BOOL CUtils::IsLotusWordPro()
{
	return !stricmp(m_szApplicationName, "wordpro.exe");
}

BOOL CUtils::IsMeadow()
{
	return !stricmp(m_szApplicationName, "Meadow95.exe") ||
		   !stricmp(m_szApplicationName, "MeadowNT.exe");
}

BOOL CUtils::IsMicrosoftFrontPage()
{
	return !stricmp(m_szApplicationName, "frontpg.exe");
}

BOOL CUtils::IsMicrosoftWord()
{
	return !stricmp(m_szApplicationName, "winword.exe");
}

BOOL CUtils::IsMozilla()
{
	return !stricmp(m_szApplicationName, "mozilla.exe");
}

BOOL CUtils::IsMuleForWin32()
{
	return !stricmp(m_szApplicationName, "mule.exe") ||
		   !stricmp(m_szApplicationName, "mulent.exe") ||
		   !stricmp(m_szApplicationName, "mulecd.exe");
}

BOOL CUtils::IsNetscape()
{
	return !stricmp(m_szApplicationName, "netscp6.exe");
}

BOOL CUtils::IsNotepad()
{
	return !stricmp(m_szApplicationName, "notepad.exe");
}

BOOL CUtils::IsOpera()
{
	return !stricmp(m_szApplicationName, "opera.exe");
}

BOOL CUtils::IsOutlook()
{
	return !stricmp(m_szApplicationName, "outlook.exe");
}

BOOL CUtils::IsOutlookExpress()
{
	return !stricmp(m_szApplicationName, "msimn.exe");
}

BOOL CUtils::IsSakuraEditor()
{
	return !stricmp(m_szApplicationName, "sakura.exe");
}

BOOL CUtils::IsTeraTermPro()
{
	return !stricmp(m_szApplicationName, "ttermpro.exe");
}

BOOL CUtils::IsVisualCpp()
{
	return !stricmp(m_szApplicationName, "msdev.exe");
}

BOOL CUtils::IsWordpad()
{
	return !stricmp(m_szApplicationName, "wordpad.exe");
}

BOOL CUtils::IsXWin()
{
	return !stricmp(m_szApplicationName, "XWin.exe");
}

BOOL CUtils::IsXyzzy()
{
	return !stricmp(m_szApplicationName, "xyzzy.exe");
}

const char *const CUtils::GetApplicationName()
{
	return m_szApplicationName;
}

void CUtils::SetApplicationName(BOOL bImeComposition)
{
		memset(m_szApplicationName, 0, sizeof(m_szApplicationName));

		if (bImeComposition) {
			HKL hKL = GetKeyboardLayout(0);
			if (ImmIsIME(hKL)) {
				ImmGetIMEFileName(hKL, m_szApplicationName, sizeof(m_szApplicationName));
				strncpy(m_szIMEName, m_szApplicationName, sizeof(m_szIMEName));
			} else {
				// ImmIsIME return 0 on Word2002, Excel2002, etc. with IME2002, so...
				// strncpy(m_szApplicationName, "imjp81.ime", sizeof(m_szApplicationName));
				strncpy(m_szApplicationName, m_szIMEName, sizeof(m_szApplicationName));
			}
		} else {
			GetModuleFileName(NULL, m_szApplicationName, sizeof(m_szApplicationName));
			CString szFn(m_szApplicationName);
			szFn.Delete(0, szFn.ReverseFind('\\') + 1);
			ZeroMemory(m_szApplicationName, sizeof(m_szApplicationName));
			strncpy(m_szApplicationName, szFn, szFn.GetLength());
			{
//				CString sz;
//				sz.Format("a%sa", m_szApplicationName);
//				AfxMessageBox(sz);
			}
			if (!m_szApplicationName[0] || !strcmp(m_szApplicationName, "xkeymacs.exe")) {
				memset(m_szApplicationName, 0, sizeof(m_szApplicationName));
				if (GetPlatformId() == VER_PLATFORM_WIN32_WINDOWS) {
					strcpy(m_szApplicationName, "WINOA386.MOD");
				} else {
					strcpy(m_szApplicationName, "CMD.exe");
				}
			}
		}
			{
//				CString sz;
//				sz.Format("a%sa", m_szApplicationName);
//				AfxMessageBox(sz);
			}
}

void CUtils::SetIMEName()
{
	HKL hKL = GetKeyboardLayout(0);
	if (ImmIsIME(hKL)) {
		ImmGetIMEFileName(hKL, m_szIMEName, sizeof(m_szIMEName));
	}
}

void CUtils::InitCUtils()
{
	GetVersionEx(&m_OsVersionInfo);
	SetIMEName();
}

BOOL CUtils::IsNTor9x()
{
	return ((m_OsVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_NT) &&
			(m_OsVersionInfo.dwMajorVersion <= 4)) ||
		   (m_OsVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS);
}

DWORD CUtils::GetPlatformId()
{
	return m_OsVersionInfo.dwPlatformId;
}

BOOL CUtils::GetClipboardText(CString *szClipboardText)
{
	if (!OpenClipboard(NULL)) {
//		AfxMessageBox("Cannot open the Clipboard");
		return FALSE;
	}

	HANDLE hClipboardText;
//	if ((hClipboardText = ::GetClipboardData(CF_TEXT)) == NULL) {
	if ((hClipboardText = ::GetClipboardData(CF_OEMTEXT)) == NULL) {
		DWORD dw = GetLastError();
		CString szMessage;
		szMessage.Format("Unable to get Clipboard data: %d", dw);
//		AfxMessageBox(szMessage);
		CloseClipboard();
		return FALSE;
	}

	szClipboardText->Format("%s", hClipboardText);
	EmptyClipboard();
	CloseClipboard();
	return TRUE;
}

BOOL CUtils::SetClipboardText(CString *szClipboardText)
{
	if (!OpenClipboard(NULL)) {
//		AfxMessageBox("Cannot open the Clipboard in SetClipboardText");
		return FALSE;
	}

	int nLength = szClipboardText->GetLength() + 1;
	HGLOBAL hClipboardText = GlobalAlloc(GHND, nLength);
	if (hClipboardText == NULL) {
//		AfxMessageBox("Failed: GlobalAlloc in SetClipboardText");
		return FALSE;
	}

	LPSTR lpStr = (LPSTR)GlobalLock(hClipboardText);
	lstrcpyn(lpStr, *szClipboardText, nLength);
	GlobalUnlock(hClipboardText);
	EmptyClipboard();

	if ((hClipboardText = ::SetClipboardData(CF_OEMTEXT, hClipboardText)) == NULL) {
//		DWORD dw = GetLastError();
//		CString szMessage;
//		szMessage.Format("Unable to set Clipboard data: %d", dw);
//		AfxMessageBox(szMessage);
		CloseClipboard();
		return FALSE;
	}

	CloseClipboard();
	return TRUE;
}

BOOL CUtils::IsDefaultIgnoreApplication()
{
	if (CUtils::IsEmacs() ||
		CUtils::IsMeadow() ||
		CUtils::IsMuleForWin32() ||
		CUtils::IsXyzzy() ||
		CUtils::IsTeraTermPro() ||
		CUtils::IsAstecX() ||
		CUtils::IsXWin()) {
		return TRUE;
	}
	return FALSE;
}

BOOL CUtils::IsDWFM()
{
	return !stricmp(m_szApplicationName, "dwfm.exe");
}

BOOL CUtils::IsK2Editor()
{
	return !stricmp(m_szApplicationName, "K2Editor.exe");
}

BOOL CUtils::IsEggExplorer()
{
	return !stricmp(m_szApplicationName, "EggExp.exe");
}

BOOL CUtils::IsDirector()
{
	return !stricmp(m_szApplicationName, "Director.exe");
}

BOOL CUtils::IsExcel()
{
	return !stricmp(m_szApplicationName, "Excel.exe");
}

BOOL CUtils::IsFireworks()
{
	return !stricmp(m_szApplicationName, "Fireworks 4.exe") ||
		   !stricmp(m_szApplicationName, "Fireworks.exe");
}

BOOL CUtils::IsDreamweaver()
{
	return !stricmp(m_szApplicationName, "Dreamweaver.exe");
}

BOOL CUtils::IsFlash()
{
	return !stricmp(m_szApplicationName, "Flash.exe");
}

BOOL CUtils::IsPhotoshop()
{
	return !stricmp(m_szApplicationName, "Photoshp.exe");
}

BOOL CUtils::IsIllustrator()
{
	return !stricmp(m_szApplicationName, "Illustrator.exe");
}

BOOL CUtils::IsMicrosoftPowerPoint()
{
	return !stricmp(m_szApplicationName, "PowerPnt.exe");
}

BOOL CUtils::IsReget()
{
	return !stricmp(m_szApplicationName, "Regetdx.exe") ||
		   !stricmp(m_szApplicationName, "Regetjr.exe");
}

BOOL CUtils::IsPaint()
{
	return !stricmp(m_szApplicationName, "mspaint.exe");
}
